<template>
  <div class="spot-additional">
    <div class="spot-additional__title">Дополнительные требования</div>
    <p class="spot-cargo-type__list">
      {{ requirementsList }}
    </p>
    <div v-if="spotComment">
      <div class="spot-additional__title spot-additional__comment">
        Комментарии
      </div>
      <div class="spot-additional__requirements">
        {{ spotComment }}
      </div>
    </div>
    <div v-if="filesLength">
      <div class="spot-additional__title spot-additional__comment">
        Приложенные файлы
      </div>
      <div
        class="existing-file"
        v-for="file in spotFiles"
        :key="file.uuid"
        @click="downloadFile(file)"
      >
        <span class="existing-file-text">{{ file.fileName }}</span>
      </div>
    </div>
    <div v-if="spotExternalNumber">
      <div class="spot-additional__title spot-additional__comment">
        Внутренний номер заказа клиента
      </div>
      <div class="spot-additional__requirements">
        {{ spotExternalNumber }}
      </div>
    </div>
    <div v-if="spotContactPerson.email || spotContactPerson.name || spotContactPerson.phone">
      <div class="spot-additional__title spot-additional__comment">
        Контактное лицо
      </div>
      <div class="spot-additional__requirements">
        <span v-if="spotContactPerson.name">{{ spotContactPerson.name }}</span>&nbsp;
        <span v-if="spotContactPerson.phone">{{ spotContactPerson.phone }}</span><br />
        <a v-if="spotContactPerson.email" href="mailto:${spotContactPerson.email}">{{ spotContactPerson.email }}</a>
      </div>
    </div>
  </div>
</template>

<script>
import api from '@/api'
import { createDownloadLink } from '@/helpers/files'

export default {
  props: {
    spotComment: {
      type: String,
      default: '',
    },
    spotExternalNumber: {
      type: String,
      default: '',
    },
    spotRequirementsList: {
      type: Array,
      default: () => [],
    },
    spotFiles: {
      type: Array,
      default: () => [],
    },
    spotContactPerson: {
      type: Object,
      default: () => {},
    }
  },
  computed: {
    requirementsList() {
      return this.spotRequirementsList.length
        ? this.spotRequirementsList
            .map((item) => item.requirementTitle)
            .join(' / ')
        : 'Не указаны'
    },
    filesLength() {
      return this.spotFiles && this.spotFiles.length
    },
  },
  methods: {
    createDownloadLink,
    async downloadFile(file) {
      const res = await api.files.getFileForDowload(file.fileUuid)
      const fileObj = {
        name: file.fileName,
        data: res.data,
      }
      this.createDownloadLink(fileObj)
    },
  },
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

.spot-additional {
  &__title {
    font-size: 12px;
    line-height: 12px;
    letter-spacing: 0.4px;
    color: $gray-slate;
  }
  &__comment {
    margin-top: 20px;
  }
  &__files {
    margin: 20px 0px 7px 0px;
  }
  &__requirements {
    font-size: 14px;
    line-height: 20px;
    letter-spacing: 0.2px;
    color: $color-text-base;
    margin-bottom: 20px;
  }
}

.existing {
  &-file {
    width: 50%;
    display: flex;
    align-items: center;
    justify-content: space-between;
    padding: 10px 15px;
    border-radius: 25px;
    background: $blue-250;
    margin-right: 20px;
    margin-top: 10px;
    min-height: 30px;
    cursor: pointer;
  }

  &-file-text {
    @include font-mixin(14px, 15px, 400, $color-text-base);
    text-align: center;
    position: relative;
    display: inline-block;
    font-size: 14px;
    border-radius: 30px;
    margin-right: 5px;
  }

  &-file-icon {
    font-size: 8px;
    font-weight: bold;
    cursor: pointer;
  }

  &-files {
    display: flex;
    flex-wrap: wrap;
  }
}
</style>
